--- chan_sip.c~	2008-12-20 20:15:27.000000000 -0500
+++ chan_sip.c	2008-12-21 00:41:35.000000000 -0500
@@ -7250,7 +7250,7 @@
 			if ((sscanf(a, "T38FaxMaxBuffer:%d", &x) == 1)) {
 				found = 1;
 				ast_debug(3, "MaxBufferSize:%d\n", x);
-			} else if ((sscanf(a, "T38MaxBitRate:%d", &x) == 1)) {
+			} else if ((sscanf(a, "T38MaxBitRate:%d", &x) == 1) || (sscanf(a, "T38FaxMaxRate:%d", &x) == 1)) {
 				found = 1;
 				ast_debug(3, "T38MaxBitRate: %d\n", x);
 				switch (x) {
@@ -7280,7 +7280,7 @@
 					peert38capability |= T38FAX_VERSION_0;
 				else if (x == 1)
 					peert38capability |= T38FAX_VERSION_1;
-			} else if ((sscanf(a, "T38FaxMaxDatagram:%d", &x) == 1)) {
+			} else if ((sscanf(a, "T38FaxMaxDatagram:%d", &x) == 1) || (sscanf(a, "T38MaxDatagram:%d", &x) == 1)) {
 				found = 1;
 				ast_debug(3, "FaxMaxDatagram: %d\n", x);
 				ast_udptl_set_far_max_datagram(p->udptl, x);
@@ -8343,25 +8343,25 @@
 	int maxrate = (t38cap & (T38FAX_RATE_14400 | T38FAX_RATE_12000 | T38FAX_RATE_9600 | T38FAX_RATE_7200 | T38FAX_RATE_4800 | T38FAX_RATE_2400));
 	
 	if (maxrate & T38FAX_RATE_14400) {
-		ast_debug(2, "T38MaxFaxRate 14400 found\n");
+		ast_debug(2, "T38MaxBitRate 14400 found\n");
 		return 14400;
 	} else if (maxrate & T38FAX_RATE_12000) {
-		ast_debug(2, "T38MaxFaxRate 12000 found\n");
+		ast_debug(2, "T38MaxBitRate 12000 found\n");
 		return 12000;
 	} else if (maxrate & T38FAX_RATE_9600) {
-		ast_debug(2, "T38MaxFaxRate 9600 found\n");
+		ast_debug(2, "T38MaxBitRate 9600 found\n");
 		return 9600;
 	} else if (maxrate & T38FAX_RATE_7200) {
-		ast_debug(2, "T38MaxFaxRate 7200 found\n");
+		ast_debug(2, "T38MaxBitRate 7200 found\n");
 		return 7200;
 	} else if (maxrate & T38FAX_RATE_4800) {
-		ast_debug(2, "T38MaxFaxRate 4800 found\n");
+		ast_debug(2, "T38MaxBitRate 4800 found\n");
 		return 4800;
 	} else if (maxrate & T38FAX_RATE_2400) {
-		ast_debug(2, "T38MaxFaxRate 2400 found\n");
+		ast_debug(2, "T38MaxBitRate 2400 found\n");
 		return 2400;
 	} else {
-		ast_debug(2, "Strange, T38MaxFaxRate NOT found in peers T38 SDP.\n");
+		ast_debug(2, "Strange, T38MaxBitRate NOT found in peers T38 SDP.\n");
 		return 0;
 	}
 }
@@ -8425,8 +8425,10 @@
 		ast_str_append(&a_modem, 0, "a=T38FaxVersion:0\r\n");
 	if ((p->t38.jointcapability & T38FAX_VERSION) == T38FAX_VERSION_1)
 		ast_str_append(&a_modem, 0, "a=T38FaxVersion:1\r\n");
-	if ((x = t38_get_rate(p->t38.jointcapability)))
+	if ((x = t38_get_rate(p->t38.jointcapability))) {
 		ast_str_append(&a_modem, 0, "a=T38MaxBitRate:%d\r\n", x);
+		ast_str_append(&a_modem, 0, "a=T38FaxMaxRate:%d\r\n", x);
+	}
 	ast_str_append(&a_modem, 0, "a=T38FaxFillBitRemoval:%d\r\n", (p->t38.jointcapability & T38FAX_FILL_BIT_REMOVAL) ? 1 : 0);
 	ast_str_append(&a_modem, 0, "a=T38FaxTranscodingMMR:%d\r\n", (p->t38.jointcapability & T38FAX_TRANSCODING_MMR) ? 1 : 0);
 	ast_str_append(&a_modem, 0, "a=T38FaxTranscodingJBIG:%d\r\n", (p->t38.jointcapability & T38FAX_TRANSCODING_JBIG) ? 1 : 0);
@@ -8434,6 +8436,7 @@
 	x = ast_udptl_get_local_max_datagram(p->udptl);
 	ast_str_append(&a_modem, 0, "a=T38FaxMaxBuffer:%d\r\n", x);
 	ast_str_append(&a_modem, 0, "a=T38FaxMaxDatagram:%d\r\n", x);
+	ast_str_append(&a_modem, 0, "a=T38MaxDatagram:%d\r\n", x);
 	if (p->t38.jointcapability != T38FAX_UDP_EC_NONE)
 		ast_str_append(&a_modem, 0, "a=T38FaxUdpEC:%s\r\n", (p->t38.jointcapability & T38FAX_UDP_EC_REDUNDANCY) ? "t38UDPRedundancy" : "t38UDPFEC");
 	len = m_modem->used + a_modem->used;
